# This Python file uses the following encoding: utf-8
"""autogenerated by genpy from cpr_common_core_msgs/Status.msg. Do not edit."""
import codecs
import sys
python3 = True if sys.hexversion > 0x03000000 else False
import genpy
import struct

import genpy
import std_msgs.msg

class Status(genpy.Message):
  _md5sum = "aef441e69efca14cebab7d5f55c8f7fa"
  _type = "cpr_common_core_msgs/Status"
  _has_header = True  # flag to mark the presence of a Header object
  _full_text = """# This message represents a CPR common core lower-frequency status updates
# Default publish frequency is 1Hz.

Header header

# Commit of firmware source.
string hardware_id
string firmware_version

# Times since MCU power-on and MCU rosserial connection, respectively.
duration uptime_mcu
duration uptime_ros_connection

# State of various stop monitors
bool stop_channel_1_monitor
bool stop_channel_2_monitor
bool stop_monitor_1
bool stop_monitor_2
bool stop_monitor_3

# State of contactor monitors
bool main_power_monitor
bool safety_contactor_monitor
bool safety2_contactor_monitor
bool charge_contactor_monitor
bool power_deck_contactor_monitor
bool c1_monitor
bool c2_monitor
bool aux_contactor_monitor

# Temperature of MCU in Celsius.
float32 mcu_temperature

# Voltage rails, in volts
# Averaged over the message period
float32 voltage_battery
float32 voltage_user_battery
float32 voltage_user_24v
float32 voltage_user_12v
float32 voltage_user_5v

# Current senses available on platform, in amps.
# Averaged over the message period
float32 current_battery
float32 current_pcba_total
float32 current_safety_24v
float32 current_computer_12v
float32 current_user_12v
float32 current_user_24v
float32 current_aux

================================================================================
MSG: std_msgs/Header
# Standard metadata for higher-level stamped data types.
# This is generally used to communicate timestamped data 
# in a particular coordinate frame.
# 
# sequence ID: consecutively increasing ID 
uint32 seq
#Two-integer timestamp that is expressed as:
# * stamp.sec: seconds (stamp_secs) since epoch (in Python the variable is called 'secs')
# * stamp.nsec: nanoseconds since stamp_secs (in Python the variable is called 'nsecs')
# time-handling sugar is provided by the client library
time stamp
#Frame this data is associated with
string frame_id
"""
  __slots__ = ['header','hardware_id','firmware_version','uptime_mcu','uptime_ros_connection','stop_channel_1_monitor','stop_channel_2_monitor','stop_monitor_1','stop_monitor_2','stop_monitor_3','main_power_monitor','safety_contactor_monitor','safety2_contactor_monitor','charge_contactor_monitor','power_deck_contactor_monitor','c1_monitor','c2_monitor','aux_contactor_monitor','mcu_temperature','voltage_battery','voltage_user_battery','voltage_user_24v','voltage_user_12v','voltage_user_5v','current_battery','current_pcba_total','current_safety_24v','current_computer_12v','current_user_12v','current_user_24v','current_aux']
  _slot_types = ['std_msgs/Header','string','string','duration','duration','bool','bool','bool','bool','bool','bool','bool','bool','bool','bool','bool','bool','bool','float32','float32','float32','float32','float32','float32','float32','float32','float32','float32','float32','float32','float32']

  def __init__(self, *args, **kwds):
    """
    Constructor. Any message fields that are implicitly/explicitly
    set to None will be assigned a default value. The recommend
    use is keyword arguments as this is more robust to future message
    changes.  You cannot mix in-order arguments and keyword arguments.

    The available fields are:
       header,hardware_id,firmware_version,uptime_mcu,uptime_ros_connection,stop_channel_1_monitor,stop_channel_2_monitor,stop_monitor_1,stop_monitor_2,stop_monitor_3,main_power_monitor,safety_contactor_monitor,safety2_contactor_monitor,charge_contactor_monitor,power_deck_contactor_monitor,c1_monitor,c2_monitor,aux_contactor_monitor,mcu_temperature,voltage_battery,voltage_user_battery,voltage_user_24v,voltage_user_12v,voltage_user_5v,current_battery,current_pcba_total,current_safety_24v,current_computer_12v,current_user_12v,current_user_24v,current_aux

    :param args: complete set of field values, in .msg order
    :param kwds: use keyword arguments corresponding to message field names
    to set specific fields.
    """
    if args or kwds:
      super(Status, self).__init__(*args, **kwds)
      # message fields cannot be None, assign default values for those that are
      if self.header is None:
        self.header = std_msgs.msg.Header()
      if self.hardware_id is None:
        self.hardware_id = ''
      if self.firmware_version is None:
        self.firmware_version = ''
      if self.uptime_mcu is None:
        self.uptime_mcu = genpy.Duration()
      if self.uptime_ros_connection is None:
        self.uptime_ros_connection = genpy.Duration()
      if self.stop_channel_1_monitor is None:
        self.stop_channel_1_monitor = False
      if self.stop_channel_2_monitor is None:
        self.stop_channel_2_monitor = False
      if self.stop_monitor_1 is None:
        self.stop_monitor_1 = False
      if self.stop_monitor_2 is None:
        self.stop_monitor_2 = False
      if self.stop_monitor_3 is None:
        self.stop_monitor_3 = False
      if self.main_power_monitor is None:
        self.main_power_monitor = False
      if self.safety_contactor_monitor is None:
        self.safety_contactor_monitor = False
      if self.safety2_contactor_monitor is None:
        self.safety2_contactor_monitor = False
      if self.charge_contactor_monitor is None:
        self.charge_contactor_monitor = False
      if self.power_deck_contactor_monitor is None:
        self.power_deck_contactor_monitor = False
      if self.c1_monitor is None:
        self.c1_monitor = False
      if self.c2_monitor is None:
        self.c2_monitor = False
      if self.aux_contactor_monitor is None:
        self.aux_contactor_monitor = False
      if self.mcu_temperature is None:
        self.mcu_temperature = 0.
      if self.voltage_battery is None:
        self.voltage_battery = 0.
      if self.voltage_user_battery is None:
        self.voltage_user_battery = 0.
      if self.voltage_user_24v is None:
        self.voltage_user_24v = 0.
      if self.voltage_user_12v is None:
        self.voltage_user_12v = 0.
      if self.voltage_user_5v is None:
        self.voltage_user_5v = 0.
      if self.current_battery is None:
        self.current_battery = 0.
      if self.current_pcba_total is None:
        self.current_pcba_total = 0.
      if self.current_safety_24v is None:
        self.current_safety_24v = 0.
      if self.current_computer_12v is None:
        self.current_computer_12v = 0.
      if self.current_user_12v is None:
        self.current_user_12v = 0.
      if self.current_user_24v is None:
        self.current_user_24v = 0.
      if self.current_aux is None:
        self.current_aux = 0.
    else:
      self.header = std_msgs.msg.Header()
      self.hardware_id = ''
      self.firmware_version = ''
      self.uptime_mcu = genpy.Duration()
      self.uptime_ros_connection = genpy.Duration()
      self.stop_channel_1_monitor = False
      self.stop_channel_2_monitor = False
      self.stop_monitor_1 = False
      self.stop_monitor_2 = False
      self.stop_monitor_3 = False
      self.main_power_monitor = False
      self.safety_contactor_monitor = False
      self.safety2_contactor_monitor = False
      self.charge_contactor_monitor = False
      self.power_deck_contactor_monitor = False
      self.c1_monitor = False
      self.c2_monitor = False
      self.aux_contactor_monitor = False
      self.mcu_temperature = 0.
      self.voltage_battery = 0.
      self.voltage_user_battery = 0.
      self.voltage_user_24v = 0.
      self.voltage_user_12v = 0.
      self.voltage_user_5v = 0.
      self.current_battery = 0.
      self.current_pcba_total = 0.
      self.current_safety_24v = 0.
      self.current_computer_12v = 0.
      self.current_user_12v = 0.
      self.current_user_24v = 0.
      self.current_aux = 0.

  def _get_types(self):
    """
    internal API method
    """
    return self._slot_types

  def serialize(self, buff):
    """
    serialize message into buffer
    :param buff: buffer, ``StringIO``
    """
    try:
      _x = self
      buff.write(_get_struct_3I().pack(_x.header.seq, _x.header.stamp.secs, _x.header.stamp.nsecs))
      _x = self.header.frame_id
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
      _x = self.hardware_id
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
      _x = self.firmware_version
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
      _x = self
      buff.write(_get_struct_4i13B13f().pack(_x.uptime_mcu.secs, _x.uptime_mcu.nsecs, _x.uptime_ros_connection.secs, _x.uptime_ros_connection.nsecs, _x.stop_channel_1_monitor, _x.stop_channel_2_monitor, _x.stop_monitor_1, _x.stop_monitor_2, _x.stop_monitor_3, _x.main_power_monitor, _x.safety_contactor_monitor, _x.safety2_contactor_monitor, _x.charge_contactor_monitor, _x.power_deck_contactor_monitor, _x.c1_monitor, _x.c2_monitor, _x.aux_contactor_monitor, _x.mcu_temperature, _x.voltage_battery, _x.voltage_user_battery, _x.voltage_user_24v, _x.voltage_user_12v, _x.voltage_user_5v, _x.current_battery, _x.current_pcba_total, _x.current_safety_24v, _x.current_computer_12v, _x.current_user_12v, _x.current_user_24v, _x.current_aux))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize(self, str):
    """
    unpack serialized message in str into this message instance
    :param str: byte array of serialized message, ``str``
    """
    if python3:
      codecs.lookup_error("rosmsg").msg_type = self._type
    try:
      if self.header is None:
        self.header = std_msgs.msg.Header()
      if self.uptime_mcu is None:
        self.uptime_mcu = genpy.Duration()
      if self.uptime_ros_connection is None:
        self.uptime_ros_connection = genpy.Duration()
      end = 0
      _x = self
      start = end
      end += 12
      (_x.header.seq, _x.header.stamp.secs, _x.header.stamp.nsecs,) = _get_struct_3I().unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.header.frame_id = str[start:end].decode('utf-8', 'rosmsg')
      else:
        self.header.frame_id = str[start:end]
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.hardware_id = str[start:end].decode('utf-8', 'rosmsg')
      else:
        self.hardware_id = str[start:end]
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.firmware_version = str[start:end].decode('utf-8', 'rosmsg')
      else:
        self.firmware_version = str[start:end]
      _x = self
      start = end
      end += 81
      (_x.uptime_mcu.secs, _x.uptime_mcu.nsecs, _x.uptime_ros_connection.secs, _x.uptime_ros_connection.nsecs, _x.stop_channel_1_monitor, _x.stop_channel_2_monitor, _x.stop_monitor_1, _x.stop_monitor_2, _x.stop_monitor_3, _x.main_power_monitor, _x.safety_contactor_monitor, _x.safety2_contactor_monitor, _x.charge_contactor_monitor, _x.power_deck_contactor_monitor, _x.c1_monitor, _x.c2_monitor, _x.aux_contactor_monitor, _x.mcu_temperature, _x.voltage_battery, _x.voltage_user_battery, _x.voltage_user_24v, _x.voltage_user_12v, _x.voltage_user_5v, _x.current_battery, _x.current_pcba_total, _x.current_safety_24v, _x.current_computer_12v, _x.current_user_12v, _x.current_user_24v, _x.current_aux,) = _get_struct_4i13B13f().unpack(str[start:end])
      self.stop_channel_1_monitor = bool(self.stop_channel_1_monitor)
      self.stop_channel_2_monitor = bool(self.stop_channel_2_monitor)
      self.stop_monitor_1 = bool(self.stop_monitor_1)
      self.stop_monitor_2 = bool(self.stop_monitor_2)
      self.stop_monitor_3 = bool(self.stop_monitor_3)
      self.main_power_monitor = bool(self.main_power_monitor)
      self.safety_contactor_monitor = bool(self.safety_contactor_monitor)
      self.safety2_contactor_monitor = bool(self.safety2_contactor_monitor)
      self.charge_contactor_monitor = bool(self.charge_contactor_monitor)
      self.power_deck_contactor_monitor = bool(self.power_deck_contactor_monitor)
      self.c1_monitor = bool(self.c1_monitor)
      self.c2_monitor = bool(self.c2_monitor)
      self.aux_contactor_monitor = bool(self.aux_contactor_monitor)
      self.uptime_mcu.canon()
      self.uptime_ros_connection.canon()
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e)  # most likely buffer underfill


  def serialize_numpy(self, buff, numpy):
    """
    serialize message with numpy array types into buffer
    :param buff: buffer, ``StringIO``
    :param numpy: numpy python module
    """
    try:
      _x = self
      buff.write(_get_struct_3I().pack(_x.header.seq, _x.header.stamp.secs, _x.header.stamp.nsecs))
      _x = self.header.frame_id
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
      _x = self.hardware_id
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
      _x = self.firmware_version
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
      _x = self
      buff.write(_get_struct_4i13B13f().pack(_x.uptime_mcu.secs, _x.uptime_mcu.nsecs, _x.uptime_ros_connection.secs, _x.uptime_ros_connection.nsecs, _x.stop_channel_1_monitor, _x.stop_channel_2_monitor, _x.stop_monitor_1, _x.stop_monitor_2, _x.stop_monitor_3, _x.main_power_monitor, _x.safety_contactor_monitor, _x.safety2_contactor_monitor, _x.charge_contactor_monitor, _x.power_deck_contactor_monitor, _x.c1_monitor, _x.c2_monitor, _x.aux_contactor_monitor, _x.mcu_temperature, _x.voltage_battery, _x.voltage_user_battery, _x.voltage_user_24v, _x.voltage_user_12v, _x.voltage_user_5v, _x.current_battery, _x.current_pcba_total, _x.current_safety_24v, _x.current_computer_12v, _x.current_user_12v, _x.current_user_24v, _x.current_aux))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize_numpy(self, str, numpy):
    """
    unpack serialized message in str into this message instance using numpy for array types
    :param str: byte array of serialized message, ``str``
    :param numpy: numpy python module
    """
    if python3:
      codecs.lookup_error("rosmsg").msg_type = self._type
    try:
      if self.header is None:
        self.header = std_msgs.msg.Header()
      if self.uptime_mcu is None:
        self.uptime_mcu = genpy.Duration()
      if self.uptime_ros_connection is None:
        self.uptime_ros_connection = genpy.Duration()
      end = 0
      _x = self
      start = end
      end += 12
      (_x.header.seq, _x.header.stamp.secs, _x.header.stamp.nsecs,) = _get_struct_3I().unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.header.frame_id = str[start:end].decode('utf-8', 'rosmsg')
      else:
        self.header.frame_id = str[start:end]
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.hardware_id = str[start:end].decode('utf-8', 'rosmsg')
      else:
        self.hardware_id = str[start:end]
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.firmware_version = str[start:end].decode('utf-8', 'rosmsg')
      else:
        self.firmware_version = str[start:end]
      _x = self
      start = end
      end += 81
      (_x.uptime_mcu.secs, _x.uptime_mcu.nsecs, _x.uptime_ros_connection.secs, _x.uptime_ros_connection.nsecs, _x.stop_channel_1_monitor, _x.stop_channel_2_monitor, _x.stop_monitor_1, _x.stop_monitor_2, _x.stop_monitor_3, _x.main_power_monitor, _x.safety_contactor_monitor, _x.safety2_contactor_monitor, _x.charge_contactor_monitor, _x.power_deck_contactor_monitor, _x.c1_monitor, _x.c2_monitor, _x.aux_contactor_monitor, _x.mcu_temperature, _x.voltage_battery, _x.voltage_user_battery, _x.voltage_user_24v, _x.voltage_user_12v, _x.voltage_user_5v, _x.current_battery, _x.current_pcba_total, _x.current_safety_24v, _x.current_computer_12v, _x.current_user_12v, _x.current_user_24v, _x.current_aux,) = _get_struct_4i13B13f().unpack(str[start:end])
      self.stop_channel_1_monitor = bool(self.stop_channel_1_monitor)
      self.stop_channel_2_monitor = bool(self.stop_channel_2_monitor)
      self.stop_monitor_1 = bool(self.stop_monitor_1)
      self.stop_monitor_2 = bool(self.stop_monitor_2)
      self.stop_monitor_3 = bool(self.stop_monitor_3)
      self.main_power_monitor = bool(self.main_power_monitor)
      self.safety_contactor_monitor = bool(self.safety_contactor_monitor)
      self.safety2_contactor_monitor = bool(self.safety2_contactor_monitor)
      self.charge_contactor_monitor = bool(self.charge_contactor_monitor)
      self.power_deck_contactor_monitor = bool(self.power_deck_contactor_monitor)
      self.c1_monitor = bool(self.c1_monitor)
      self.c2_monitor = bool(self.c2_monitor)
      self.aux_contactor_monitor = bool(self.aux_contactor_monitor)
      self.uptime_mcu.canon()
      self.uptime_ros_connection.canon()
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e)  # most likely buffer underfill

_struct_I = genpy.struct_I
def _get_struct_I():
    global _struct_I
    return _struct_I
_struct_3I = None
def _get_struct_3I():
    global _struct_3I
    if _struct_3I is None:
        _struct_3I = struct.Struct("<3I")
    return _struct_3I
_struct_4i13B13f = None
def _get_struct_4i13B13f():
    global _struct_4i13B13f
    if _struct_4i13B13f is None:
        _struct_4i13B13f = struct.Struct("<4i13B13f")
    return _struct_4i13B13f
